function prob = performPreAssembling(fem,prob)

  prob.fem.pre.theta.lhs = @(mu) zeros(0,size(mu,2));
  prob.fem.pre.theta.rhs = @(mu) zeros(0,size(mu,2));
  prob.fem.pre.equFull.lhs = cell(1,0);
  prob.fem.pre.equFull.rhs = zeros(prob.fem.dof.num,0);
  for q=1:numel(prob.theta)

    theta = zeros(numel(prob.theta),1);
    theta(q) = 1;
    fem.const(2:2:end) = num2cell(theta);
    
    [K1,L1] = assemble(fem,'Out',{'K','L'});
    
    theta = 2*theta;
    fem.const(2:2:end) = num2cell(theta);
    
    [K2,L2] = assemble(fem,'Out',{'K','L'});

    Kconst = 2*K1-K2;
    Klin = K1-Kconst;
    Lconst = 2*L1-L2;
    Llin = L1-Lconst;

    if (q==1)
      if (nnz(Kconst)>0)
        prob.fem.pre.equFull.lhs{1} = Kconst;
        prob.fem.pre.theta.lhs = @(mu) ones(1,size(mu,2));
      end
      if any(Lconst)
        prob.fem.pre.equFull.rhs = Lconst;
        prob.fem.pre.theta.rhs = @(mu) ones(1,size(mu,2));
      end
    end
      
    if (nnz(Klin)>0)
      prob.fem.pre.equFull.lhs{end+1} = Klin;
      prob.fem.pre.theta.lhs = @(mu) [prob.fem.pre.theta.lhs(mu); ...
                                      prob.theta(q).fun(mu)];
    end
  
    if any(Llin)
      prob.fem.pre.equFull.rhs = [prob.fem.pre.equFull.rhs Llin];
      prob.fem.pre.theta.rhs = @(mu) [prob.fem.pre.theta.rhs(mu); ...
                                      prob.theta(q).fun(mu)];
      
    end
  end
  
  ind = prob.fem.dof.ind;
  prob.fem.pre.equ.lhs = cell(size(prob.fem.pre.equFull.lhs));
  prob.fem.pre.equSymm.lhs = cell(size(prob.fem.pre.equFull.lhs));
  for q=1:numel(prob.fem.pre.equFull.lhs)
    prob.fem.pre.equ.lhs{q} = prob.fem.pre.equFull.lhs{q}(ind,ind);
    prob.fem.pre.equSymm.lhs{q} = ...
      (prob.fem.pre.equFull.lhs{q}(ind,ind) + ...
       prob.fem.pre.equFull.lhs{q}(ind,ind)')/2;
  end
  prob.fem.pre.equ.rhs = prob.fem.pre.equFull.rhs(ind,:);