function scm = scm_offline(prob,scm)

  linprog_options = optimset('display','off');
  eigs_options = struct('disp',0,'maxit',1000,'tol',1e-14);

% comute Theta for all mu in Xi_train  
  Theta = prob.fem.pre.theta.lhs(scm.Xi_train);
  
% determine box B_Q
  Q = numel(prob.fem.pre.equSymm.lhs);
  sigma_minus = zeros(Q,1);
  sigma_plus = zeros(Q,1);
  % ====== TODO ==========
  ….
  % ======================
    
% find nearst "points" for all mu in Xi_train  
  nearest_Xi = zeros(scm.n_train,scm.n_train,'uint16');
  for n=1:scm.n_train
    difference = (scm.Xi_train-repmat(scm.Xi_train(:,n),1,scm.n_train));
    distance = sqrt(sum(difference.^2));
    [dummy,tmp] = sort(distance);
    nearest_Xi(:,n) = uint16(tmp);
  end

% start greedy  
  C = zeros(scm.K_max,1,'uint16');
  C(1) = 1;
  max_err_alpha = zeros(scm.K_max,1);
  S_ub = zeros(scm.K_max,Q);

  alpha_lb = zeros(scm.n_train,1);
  alpha = zeros(scm.n_train,1);
  alpha_ub = inf*ones(scm.n_train,1);
  linprog_ef = zeros(scm.n_train,1,'int8');
  
  for K=1:scm.K_max
    
  % compute coercivity constant and z_star
    % ====== TODO ==========
    % S_ub = ….
    % ======================

  % determine P_M_alpha
    if K<=scm.M_alpha
      P_M_alpha = repmat(C(1:K),1,scm.n_train);
    % ====== TODO ==========
    % else
    % …
    % ======================
    end

  % determine alpha_lb and alpha_ub
  % ====== TODO ==========
  ….
  % ======================

  % compute maximum gap and corresponding index    
    [max_err_alpha(K),max_ind] = max((alpha_ub-alpha_lb)./alpha_ub);
  
  % status
    disp(sprintf('K = %d',K));
    C(1:K)'
    max_err_alpha(1:K)'
    all_converged = all(linprog_ef==1)
    min_alpha = min(alpha(C(1:K)))
    min([alpha(C(1:K))-alpha_lb(C(1:K)) alpha_ub(C(1:K))-alpha(C(1:K))],[],1)
    
  % check termination criteria    
    if (max_err_alpha(K)<scm.eps_alpha)
      disp('gap smaller than eps_alpha -> break');
      break;
    end
    
    if (K==scm.K_max)
      disp('K_max reached -> break');
      break;
    end
  
  % add index to C
    C(K+1) = max_ind;
  end
  
  scm.K_max = K;
  scm.max_err_alpha = max_err_alpha(1:K);
  scm.S_ub = S_ub(1:K,:);
  scm.sigma_minus = sigma_minus;
  scm.sigma_plus = sigma_plus;
  scm.alpha = alpha(C(1:K));
  scm.Theta = Theta(:,C(1:K));
  scm.C = scm.Xi_train(:,C(1:K));